;
;	SD card file control program
;
	ORG	0000H
;

FIRMVER:	EQU	00030H

;FIRMVER:	EQU	0FFFFH	; decode address for debug

;
; buffer location
;
REG_SDBUF:	EQU	8000H
REG_OFFSET:	EQU	81C6H

BPB_SECBYTE	EQU	800BH
BPB_DIRENTRY	EQU	8011H
BPB_FATVER:	EQU	803AH
BPB_CLASTSEC:	EQU	800DH
BPB_FATST:	EQU	800EH
BPB_FATNUM:	EQU	8010H
BPB_FATSEC:	EQU	8016H

;
; register mapping
;
REG_SDCMDST:	EQU	8200H
REG_SDCTRL:	EQU	8201H
REG_SDCMDNO:	EQU	8202H
REG_SDADD:	EQU	8203H
REG_FPGAVER:	EQU	820CH
REG_FIRMVER:	EQU	820EH

REG_BUFS:	EQU	8210H
REG_BUFCTRL:	EQU	8211H
REG_BUFRDREQ:	EQU	8212H
REG_FIFOCTRL:	EQU	8213H
REG_FIFOTYPE:	EQU	8214H
REG_FIFOWRREQ:	EQU	8215H
REG_ROMSTART:	EQU	8216H
REG_CMTLEN:	EQU	821AH
REG_CMTOPEN:	EQU	821EH
REG_CMTWNOM:	EQU	8220H
REG_CMTWACCL:	EQU	8224H
REG_CMTWACCH:	EQU	8228H
REG_CMTWST:	EQU	822CH

REG_LCDMODE:	EQU	8400H
REG_LCDADD:	EQU	8401H
REG_LCDDAT:	EQU	8402H
REG_LCDST:	EQU	8403H
REG_LCDDONE:	EQU	8404H
REG_CTRLSEL:	EQU	8410H
REG_CTRLRST:	EQU	8411H
REG_MEM16K:	EQU	8412H
REG_SC4MODE:	EQU	8413H
REG_TAPEACC:	EQU	8414H
REG_MK2MODE:	EQU	8415H

REG_FUNCKEY:	EQU	8420H

F_BASICROM:	EQU	8480H
F_CGROM:	EQU	8490H
F_CG2ROM:	EQU	84A0H
F_KANJIROM:	EQU	84B0H
F_VOICEROM:	EQU	84C0H

CTRLATT:	EQU	0C000H
CTRLVRAM:	EQU	0C200H

;

START:

	LD	SP,0FFFH
	LD	A,0FFH
	LD	I,A
	EI
	LD	HL,FIRMVER
	LD	(REG_FIRMVER),HL

		;
	CALL	LCD_INIT

	CALL	SCREENINIT

		;
;	LD	HL,0EEEEH
;	LD	(REG_CMTWNOM),HL
;	LD	HL,0007H
;	LD	(REG_CMTWNOM+2),HL
;	LD	HL,0002H
;	LD	(REG_CMTWACCL),HL
;	LD	HL,0001H
;	LD	(REG_CMTWACCL+2),HL
;	LD	HL,0002H
;	LD	(REG_CMTWACCH),HL
;	LD	HL,0001H
;	LD	(REG_CMTWACCH+2),HL
;	LD	HL,0000H
;	LD	(REG_CMTWST),HL
;	LD	HL,0010H
;	LD	(REG_CMTWST+2),HL

	XOR	A
	LD	(SDMODE),A

		;

	CALL	SDCARD_OPEN
	CALL	ROOTDIRSET

	LD	A,01H
	LD	(REG_FIFOTYPE),A

		;
		; BASICROM read
		;
		; REG_FIFOTYPE <= 01H
		;
	LD	IX,F_BASICROM
	CALL	FILESEARCH
		;
		;
	LD	HL,0000H
	LD	(REG_ROMSTART),HL
	LD	HL,0002H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,RDM2_B
	LD	HL,0003H
RDM2_B:
	LD	(REG_ROMSTART+2),HL
	XOR	A
	LD	(FILESECCNT),A
	CALL	FILEREAD

		;
		; CGROM read
		;
		; REG_FIFOTYPE <= 01H
		;
	LD	IX,F_CGROM
	CALL	FILESEARCH
		;
		;
	LD	HL,0A000H
	LD	(REG_ROMSTART),HL
	LD	HL,0002H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,RDM2_C
	LD	HL,0003H
RDM2_C:
	LD	(REG_ROMSTART+2),HL
	XOR	A
	LD	(FILESECCNT),A
	CALL	FILEREAD


	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,READEND

		;
		; CG2ROM read
		;
		; REG_FIFOTYPE <= 01H
		;
	LD	IX,F_CG2ROM
	CALL	FILESEARCH
		;
		;
	LD	HL,08000H
	LD	(REG_ROMSTART),HL
	LD	HL,0003H
	LD	(REG_ROMSTART+2),HL
	XOR	A
	LD	(FILESECCNT),A
	CALL	FILEREAD

		;
		; KANJIROM read
		;
		; REG_FIFOTYPE <= 01H
		;
	LD	IX,F_KANJIROM
	CALL	FILESEARCH
		;
		;
	LD	HL,0000H
	LD	(REG_ROMSTART),HL
	LD	HL,0004H
	LD	(REG_ROMSTART+2),HL
	XOR	A
	LD	(FILESECCNT),A
	CALL	FILEREAD

		;
		; VOICEROM read
		;
		; REG_FIFOTYPE <= 01H
		;
	LD	IX,F_VOICEROM
	CALL	FILESEARCH
		;
		;
	LD	HL,0C000H
	LD	(REG_ROMSTART),HL
	LD	HL,0003H
	LD	(REG_ROMSTART+2),HL
	XOR	A
	LD	(FILESECCNT),A
	CALL	FILEREAD

READEND:
	XOR	A
	LD	(REG_FIFOTYPE),A

	CALL	ROMINIT

	LD	A,04H
	LD	(REG_SDCTRL),A

	LD	A,01H
	LD	(SDMODE),A

;
;
;
MAINSTART:
	LD	A,02H
	LD	(SDMODE),A
	CALL	SDCARD_OPEN
	CALL	ROOTDIRSET
MAINST2:
	LD	A,01H
	LD	(SDMODE),A
	LD	HL,0FFFFH
	LD	(FILECLASTNO),HL
	LD	(FILECLASTINITNO),HL
	XOR	A
	LD	(READFLAG),A

	LD	HL,REG_FIFOCTRL
	LD	(HL),02H
	LD	(HL),00H
	LD	A,04H
	LD	(REG_FIFOTYPE),A
	LD	(REG_SDCTRL),A
	XOR	A
	LD	(FILESECCNT),A

	LD	HL,CTRLNOW
	XOR	A
	LD	B,0CH
MLP00:	LD	(HL),A
	INC	HL
	DJNZ	MLP00

	LD	DE,ST_CMTREAD_VAL
	LD	HL,ST_NOSELECT
	LD	BC,000CH
	LDIR
	LD	DE,ST_EXTROM_VAL
	LD	HL,ST_NOSELECT
	LD	BC,000CH
	LDIR

	XOR	A
	LD	(EXTROMFLAG),A
	LD	(FILEEXTROM),A

;
; main loop
;
MLP10:
	CALL	KEYDET
	LD	A,(FUNCPUSH+1)
	AND	08H
	JR	Z,MLP11

	LD	HL,REG_CTRLSEL
	LD	(HL),01H
	LD	(HL),00H
;	LD	HL,REG_CTRLRST
;	LD	(HL),01H
;	LD	(HL),00H
	JR	MLP10

MLP11:
	CALL	CMTREADWAIT

	LD	A,(CTRLNOW)
	AND	04H
	JR	Z,MLP10
	LD	A,(CTRLPUSH)
	AND	04H

	CALL	NZ,PAGEINIT

;
; control panel display
;
MLP12:

	CALL	DISPPAGE
	CALL	DISPCUR

	CALL	KEYINPAGE

	JR	MLP10


;
; page # keyin process
;
KEYINPAGE:
	LD	A,(PAGENUM)
	OR	A
	JP	Z,KEYINPAGE0
	CP	01H
	JP	Z,KEYINPAGE1
	CP	02H
	JP	Z,KEYINPAGE2

	RET

;
; page 0 keyin process
;
KEYINPAGE0:

	LD	HL,FUNCPUSH
		; F7 - F0,ESC

	INC	HL
		; TAB,RETURN,SPACE,F12 - F8

	BIT	6,(HL)
	JP	Z,KP0L0

;
; return
;
	LD	A,01H
	LD	(PAGEREDRAW),A
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	A,H
KP0L00:	SUB	03H
	JR	NZ,KP0L01

	XOR	A
	LD	(FILEEXTROM),A
	INC	A
	LD	(PAGENUM),A
	RET

KP0L01:	CP	01H
	JR	NZ,KP0L03

	LD	HL,REG_FIFOCTRL
	LD	(HL),02H
	LD	(HL),00H
	LD	DE,FILECLASTNO
	LD	HL,FILECLASTINITNO
	LD	BC,0002H
	LDIR
	LD	A,(READFLAG)
	OR	A
	RET	Z
	LD	A,01H
	LD	(READFLAG),A
	RET

KP0L03:	CP	03H
	JR	NZ,KP0L05

	RET

KP0L05:	CP	05H
	JR	NZ,KP0L07

	LD	HL,REG_MEM16K
	LD	A,(HL)
	XOR	01H
	LD	(HL),A

	LD	HL,REG_CTRLRST
	LD	(HL),01H
	LD	(HL),00H
	RET

KP0L07:	CP	07H
	JR	NZ,KP0L09

	LD	A,01H
	LD	(FILEEXTROM),A
	LD	(PAGENUM),A
	RET

KP0L09:	CP	09H
	RET	NZ

	LD	HL,REG_SC4MODE
	LD	A,(HL)
	BIT	4,A
	JR	NZ,KP0L091
	OR	10H
	AND	0FCH
	LD	(HL),A
	RET

KP0L091:
	AND	03H
	INC	A
	AND	03H
	LD	B,A
	LD	A,(HL)
	JR	NZ,KP0L092
	AND	0EFH
KP0L092:
	AND	0FCH
	OR	B
	LD	(HL),A
	RET


KP0L0:	INC	HL
		; END,ALT,SHIFT,CTRL,<-,->,v,^

	BIT	0,(HL)
	JR	Z,KP0L1

;
; cursor up
;
	LD	C,0FFH
	JR	PAGE0CURMOV

KP0L1:
	BIT	1,(HL)
	RET	Z

;
; cursor down
;
	LD	C,01H
	JR	PAGE0CURMOV

;
; page 0 keyin sub
;
PAGE0CURMOV:
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	A,H
	SUB	03H

	ADD	A,C
	CP	0AH
	RET	NC

	CP	02H
	JR	NZ,P0CL0
	ADD	A,C
P0CL0:
	CP	04H
	JR	NZ,P0CL1
	ADD	A,C
P0CL1:
	CP	06H
	JR	NZ,P0CL2
	ADD	A,C
P0CL2:
	CP	08H
	JR	NZ,P0CL3
	ADD	A,C
P0CL3:
	LD	B,A
	ADD	A,A
	ADD	A,B
	LD	E,A
	LD	D,00H
	LD	HL,PAGE0CURDATA
	ADD	HL,DE
	LD	DE,CURSOR_ADD
	LD	BC,0003H
	LDIR

	RET


;
; page 1 keyin process
;
KEYINPAGE1:

	LD	HL,FUNCPUSH
		; F7 - F0,ESC

	BIT	0,(HL)
	JR	Z,KP1L0

;
; ESC
;
PAGEINIT:
	XOR	A
	LD	(PAGENUM),A
	LD	(DIRFLAG),A
	INC	A
	LD	(PAGEREDRAW),A
	LD	(CURSORREDRAW),A
	LD	HL,0FFFFH
	LD	(DIRFILEPTR),HL

	LD	HL,PAGE0CURDATA
	LD	DE,CURSOR_ADD
	LD	BC,0003H
	LDIR

	RET

KP1L0:	INC	HL
		; TAB,RETURN,SPACE,F12 - F8

	BIT	5,(HL)
	JR	Z,KP1L1

;
; space
;
KP1L00:
	LD	A,01H
	LD	(PAGENUM),A
	LD	(PAGEREDRAW),A
	LD	(CURSORREDRAW),A
	RET

KP1L1:	BIT	6,(HL)
	JP	Z,KP1L2

;
; return
;
	LD	A,05H
	LD	(REG_SDCTRL),A
	CALL	SDCARD_OPEN

	LD	HL,(CURSOR_ADD)
	CALL	CUR2BUF
	INC	HL
	LD	A,H
	OR	L
	JR	NZ,KP1L110

;
; file "no select"
;
	LD	A,(FILEEXTROM)
	OR	A
	JR	Z,KP1L113

;
; EXT.ROM "no select"
;
	CALL	ROMINIT

	LD	HL,REG_SDCTRL
	LD	(HL),04H

	XOR	A
	LD	(EXTROMFLAG),A
	JR	KP1L113


KP1L110:
	DEC	HL
	LD	(DIRFILEPTR),HL
	CALL	READ_DIRFILE

	LD	A,04H
	LD	(REG_SDCTRL),A

	PUSH	HL
	LD	BC,000BH
	ADD	HL,BC
	LD	A,(HL)
	AND	10H
	POP	HL
	JP	NZ,KP1L11

	CALL	FSL2

	LD	A,(FILEEXTROM)
	OR	A
	JR	Z,KP1L111

;
; EXT.ROM
;
	CALL	ROMINIT

	LD	HL,REG_SDCTRL
	LD	(HL),01H

	LD	HL,0C000H
	LD	(REG_ROMSTART),HL
	LD	HL,0002H
	LD	(REG_ROMSTART+2),HL
	LD	A,01H
	LD	(REG_FIFOTYPE),A
	XOR	A
	LD	(FILESECCNT),A
	CALL	FILEREAD
	LD	A,04H
	LD	(REG_FIFOTYPE),A

	LD	A,01H
	LD	(EXTROMFLAG),A

KP1L113:
	LD	HL,REG_SDCTRL
	LD	(HL),04H

	LD	HL,0FFFFH
	LD	(FILECLASTNO),HL
	LD	(FILECLASTINITNO),HL
	XOR	A
	LD	(READFLAG),A
	LD	DE,ST_CMTREAD_VAL
	LD	HL,ST_NOSELECT
	LD	BC,000CH
	LDIR

	LD	DE,ST_EXTROM_VAL
	JR	KP1L112

;
; CMT read
;
KP1L111:
	LD	A,01H
	LD	(READFLAG),A
	LD	DE,ST_CMTREAD_VAL
KP1L112:
	LD	HL,(CURSOR_ADD)
	LD	BC,CTRLVRAM
	ADD	HL,BC
	LD	BC,000CH
	LDIR

	CALL	PAGEINIT

	LD	HL,REG_FIFOCTRL
	LD	(HL),02H
	LD	(HL),00H

	RET

;
; directory select
;
KP1L11:
	LD	BC,001AH
	ADD	HL,BC
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL

	LD	A,H
	OR	L
	JR	Z,KP1L15

	LD	(FILECLASTNO),HL
	LD	(FILECLASTINITNO),HL

		;
		; claster number -> address
		;
		; DIRST <= CLASTST + CLASTSIZE x (FILECLASTNO - 2)
		;
KP1L12:
	LD	DE,DIRST
	LD	HL,CLASTST
	LD	BC,0004H
	LDIR
		;
	LD	HL,(FILECLASTNO)
	DEC	HL
	DEC	HL
	LD	(WORK),HL
	LD	HL,0000H
	LD	(WORK+2),HL
		;	
	LD	A,(CLASTSIZE)
	LD	B,08H
KP1L14:	RRCA
	PUSH	AF
	PUSH	BC
	JR	NC,KP1L13
	LD	HL,DIRST
	LD	DE,WORK
	CALL	ADD4B_MHL_MDE
		;
KP1L13:	LD	HL,WORK
	CALL	SHT4B_MHL
		;
	POP	BC
	POP	AF
	DJNZ	KP1L14


	LD	HL,0000H
	LD	(DIRFILEPTR),HL
	LD	A,01H
	LD	(DIRFLAG),A
	JP	KP1L00

KP1L15:	CALL	ROOTDIRSET
	LD	HL,0FFFFH
	LD	(DIRFILEPTR),HL
	XOR	A
	LD	(DIRFLAG),A
	JP	KP1L00


KP1L2:	INC	HL
		; END,ALT,SHIFT,CTRL,<-,->,v,^

	BIT	0,(HL)
	JR	Z,KP1L3

;
; cursor up
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	EX	DE,HL
	LD	HL,0072H
	OR	A
	SBC	HL,DE
	RET	NC

	LD	HL,0020H
	EX	DE,HL
	OR	A
	SBC	HL,DE
	LD	(CURSOR_ADD),HL

	RET

KP1L3:
	BIT	1,(HL)
	JR	Z,KP1L4

;
; cursor down
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	EX	DE,HL
	LD	HL,0182H-1
	OR	A
	SBC	HL,DE
	RET	C

	LD	HL,(CURSOR_ADD)
	LD	DE,0020H
	ADD	HL,DE
	CALL	CUR2CHK
	RET	Z

	LD	HL,(CURSOR_ADD)
	LD	DE,0020H
	ADD	HL,DE
	LD	(CURSOR_ADD),HL
	RET

KP1L4:
	BIT	2,(HL)
	JR	Z,KP1L5

;
; cursor right
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	LD	A,L
	AND	1FH
	CP	12H
	RET	NC

	LD	HL,(CURSOR_ADD)
	LD	DE,0010H
	ADD	HL,DE
	CALL	CUR2CHK
	RET	Z

	LD	HL,(CURSOR_ADD)
	LD	DE,0010H
	ADD	HL,DE
	LD	(CURSOR_ADD),HL

	RET

KP1L5:
	BIT	3,(HL)
	RET	Z

;
; cursor left
;
	LD	A,01H
	LD	(CURSORREDRAW),A

	LD	HL,(CURSOR_ADD)
	LD	A,L
	AND	1FH
	CP	02H+1
	RET	C

	LD	DE,0010H
	OR	A
	SBC	HL,DE
	LD	(CURSOR_ADD),HL

	RET



;
; cursor position -> file buffer positon (keyin 1 sub)
;
; HL <- cursor position
;
; RETURN HL:file buffer position
;
CUR2BUF:
	LD	DE,0062H
	OR	A
	SBC	HL,DE
	SRL	H
	RR	L
	SRL	H
	RR	L
	SRL	H
	RR	L
	LD	DE,FILEPTR_BUF
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	RET

;
; cursor position -> file buffer positon (keyin 1 sub)
;
; HL <- cursor position
;
; RETURN Zflag set:file NULL
;
CUR2CHK:
	CALL	CUR2BUF
	INC	HL
	LD	A,L
	OR	H
	RET

;
; page 2 keyin process
;
KEYINPAGE2:

	RET


;
; page # display
;
DISPPAGE:
	LD	A,(PAGEREDRAW)
	OR	A
	RET	Z

	CALL	SCREENINIT

	XOR	A
	LD	(PAGEREDRAW),A
	INC	A
	LD	(CURSORREDRAW),A

	LD	A,(PAGENUM)
	OR	A
	JP	Z,DISPPAGE0
	CP	01H
	JP	Z,DISPPAGE1
	CP	02H
	JP	Z,DISPPAGE2

	RET


;
; page 0 display
;
DISPPAGE0:
	LD	HL,ST_32
	LD	A,(REG_MEM16K)
	OR	A
	JR	Z,DP0L2
	LD	HL,ST_16
DP0L2:
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,DP0L21
	LD	HL,ST_64
	LD	A,(REG_MEM16K)
	OR	A
	JR	Z,DP0L21
	LD	HL,ST_128
DP0L21:
	LD	DE,ST_MEMSIZE_VAL
	LD	BC,0003H
	LDIR

	LD	HL,ST_SC4COLOFF
	LD	A,(REG_SC4MODE)
	BIT	4,A
	JR	Z,DP0L5
	LD	HL,ST_SC4COL0
	AND	03H
	JR	Z,DP0L5
	LD	HL,ST_SC4COL1
	CP	01H
	JR	Z,DP0L5
	LD	HL,ST_SC4COL2
	CP	02H
	JR	Z,DP0L5
	LD	HL,ST_SC4COL3
DP0L5:	LD	DE,ST_SC4COL_VAL
	LD	BC,0008H
	LDIR

	LD	HL,ST_CMTREAD
	CALL	PRINTSTRING
	LD	HL,ST_CMTREW
	CALL	PRINTSTRING
;	LD	HL,ST_TAPEACC
;	CALL	PRINTSTRING
	LD	HL,ST_CMTWRITE
	CALL	PRINTSTRING
	LD	HL,ST_MEMSIZE
	CALL	PRINTSTRING
	LD	HL,ST_EXTROM
	CALL	PRINTSTRING
	LD	HL,ST_SC4COL
	CALL	PRINTSTRING

	XOR	A
	LD	(DIRFLAG),A

	RET

;
; page 1 display
;
DISPPAGE1:
	LD	B,28H
	LD	HL,FILEPTR_BUF
P1LP10:	LD	(HL),0FFH
	INC	HL
	DJNZ	P1LP10

	LD	HL,0062H
	LD	(ST_FNAME),HL

	LD	A,05H
	LD	(REG_SDCTRL),A
	CALL	SDCARD_OPEN

	LD	A,(DIRFLAG)
	OR	A
	CALL	Z,ROOTDIRSET


P1LP11:	LD	B,14H
	LD	DE,FILEPTR_BUF
P1LP13:	PUSH	BC
	PUSH	DE
P1LP15: LD	HL,(DIRFILEPTR)
	INC	HL
	LD	A,H
	OR	L
	JP	Z,P1LP151

	CALL	READ_DIRFILE

	PUSH	HL
	LD	HL,(DIRFILEPTR)
	INC	HL
	LD	(DIRFILEPTR),HL
	LD	A,H
	POP	HL
	CP	02H
	JR	NC,P1LP14

	LD	A,(HL)
	OR	A
	JR	Z,P1LP14
	CP	05H
	JR	Z,P1LP15
	CP	0E5H
	JR	Z,P1LP15
	CP	"."
	JR	NZ,P1LP16
	INC	HL
	LD	A,(HL)
	DEC	HL
	CP	" "
	JR	Z,P1LP15

P1LP16: LD	DE,ST_FNAME_VAL
	LD	BC,0008H
	LDIR
	LD	A,"."
	LD	(DE),A
	INC	DE
	LD	BC,0003H
	LDIR
	LD	A,(HL)
	LD	B,A
	AND	0EH
	JR	NZ,P1LP15
	LD	A,B
	AND	10H
	JR	Z,P1LP18
	LD	A,"="
	DEC	DE
	LD	(DE),A
	DEC	DE
	LD	(DE),A
	DEC	DE
	LD	(DE),A
	DEC	DE
	LD	(DE),A

P1LP18:	LD	HL,DIRFILEPTR
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	DEC	DE
	POP	HL
	PUSH	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D

	LD	HL,ST_FNAME
	CALL	PRINTSTRING

	LD	HL,(ST_FNAME)
	LD	DE,0010H
	ADD	HL,DE
	LD	(ST_FNAME),HL
	POP	DE
	INC	DE
	INC	DE
	POP	BC
	DJNZ	P1LP13

P1LP12: LD	A,04H
	LD	(REG_SDCTRL),A

	LD	HL,0062H
	LD	(CURSOR_ADD),HL
	LD	A,0CH
	LD	(CURSOR_LEN),A
	RET

P1LP14: POP	DE
	POP	BC
	LD	HL,0FFFFH
	LD	A,(DIRFLAG)
	OR	A
	JR	Z,P1LP141
	INC	HL
P1LP141:
	LD	(DIRFILEPTR),HL
	LD	A,B
	CP	14H
	JP	Z,P1LP11
	JR	P1LP12

P1LP151:
	LD	(DIRFILEPTR),HL
	LD	DE,ST_FNAME_VAL
	LD	HL,ST_NOSELECT
	LD	BC,000CH
	LDIR
	JR	P1LP18


;
; page 2 display
;
DISPPAGE2:

	RET

;
; cursor display
;
DISPCUR:
	LD	A,(CURSORREDRAW)
	OR	A
	RET	Z

	LD	DE,CTRLATT+41H
	LD	HL,CTRLATT+40H
	LD	BC,017FH

	LD	(HL),22H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,DCL2
	LD	(HL),20H
DCL2:
	LDIR

	LD	A,(CURSOR_LEN)
	LD	B,A
	LD	HL,(CURSOR_ADD)
	LD	DE,CTRLATT
	ADD	HL,DE
DCL1:	LD	(HL),23H
	INC	HL
	DJNZ	DCL1

	XOR	A
	LD	(CURSORREDRAW),A
	RET


;
; screen initialize
;
SCREENINIT:
	LD	DE,CTRLATT+1
	LD	HL,CTRLATT
	LD	BC,0040H
	LD	(HL),23H
	LDIR
	LD	BC,0180H
	LD	(HL),22H
	LD	A,(REG_MK2MODE)
	OR	A
	JR	Z,SIL1
	LD	(HL),20H
SIL1:
	LDIR
	LD	BC,0040H
	LD	(HL),23H
	LDIR
	LD	BC,01FFH
	LD	(HL),20H
	LDIR

	LD	HL,(REG_FIRMVER)
	LD	DE,ST_FIRMVER_VAL
	CALL	VER_CONV
	LD	HL,(REG_FPGAVER)
	LD	DE,ST_FPGAVER_VAL
	CALL	VER_CONV

	LD	HL,ST_PC6001F
	CALL	PRINTSTRING
	LD	HL,ST_FPGAVER
	CALL	PRINTSTRING
	LD	HL,ST_FIRMVER
	CALL	PRINTSTRING

	LD	HL,ST_KEYFUNC1
	CALL	PRINTSTRING
	LD	HL,ST_KEYFUNC2
	CALL	PRINTSTRING

	RET

;
; version number convert
;
VER_CONV
	LD	B,02H

VCL1:
	LD	A,H
	AND	0F0H
	RRCA
	RRCA
	RRCA
	RRCA
	ADD	A,30H
	CP	3AH
	JR	C,VCL2
	ADD	A,07H
VCL2:	LD	(DE),A
	INC	DE
	LD	A,H
	AND	0FH
	ADD	A,30H
	CP	3AH
	JR	C,VCL3
	ADD	A,07H
VCL3:	LD	(DE),A
	INC	DE
	LD	H,L
	DJNZ	VCL1
	RET


;
; print strings
;
; HL <- pointer of strings with display address
;
PRINTSTRING:
	LD	DE,CTRLVRAM
	LD	C,(HL)
	INC	HL
	LD	B,(HL)
	INC	HL
	EX	DE,HL
	ADD	HL,BC
	EX	DE,HL

PSL1:
	LD	A,(HL)
	OR	A
	RET	Z
	LD	(DE),A
	INC	HL
	INC	DE
	JR	PSL1


;
; debug
;
; HL <- print number
;
;PRINTHL:
;	LD	DE,ST_DEBUG_VAL
;	CALL	VER_CONV
;	LD	HL,ST_DEBUG
;	CALL	PRINTSTRING
;	RET


;
; key push detect
;
KEYDET:
	LD	HL,CTRLNOW
	LD	DE,CTRLBEF
	LD	IX,REG_CTRLSEL
	LD	IY,CTRLPUSH
	LD	B,04H

KDLP1:	LD	A,(HL)
	LD	(DE),A
	LD	A,(IX+00H)
	LD	(HL),A
	LD	A,(DE)
	XOR	(HL)
	AND	(HL)
	LD	(IY+00H),A

	INC	HL
	INC	DE
	INC	IY
	LD	A,B
	CP	04H
	JR	NZ,KDLP2
	LD	IX,REG_FUNCKEY-1
KDLP2:	INC	IX
	DJNZ	KDLP1

	RET


;
; read file
;
CMTREADWAIT:
	LD	A,(READFLAG)
	OR	A
	RET	Z
	DEC	A
	JR	NZ,CRWL1

	LD	A,(REG_CMTOPEN)
	AND	01H
	RET	Z

	XOR	A
	LD	(FILESECCNT),A
	LD	A,05H
	LD	(REG_SDCTRL),A
	CALL	FILEREAD
	LD	A,04H
	LD	(REG_SDCTRL),A
	LD	A,02H
	LD	(READFLAG),A
	RET

;
; read file (continue)
;
CRWL1:
	LD	A,(REG_CMTOPEN)
	AND	01H
	RET	Z

	LD	A,05H
	LD	(REG_SDCTRL),A
	CALL	READCONT
	LD	A,04H
	LD	(REG_SDCTRL),A
	RET


;
; file read
;
FILEREAD:
	LD	HL,(FILECLASTNO)
	INC	HL
	LD	A,H
	OR	L
	JP	Z,SDERR
	LD	HL,REG_FIFOCTRL
	LD	(HL),02H
	LD	(HL),00H
		;
FRL1:
	CALL	CALCSECAD
	CALL	READ1SEC
		;
	XOR	A
	LD	(REG_BUFCTRL),A
	LD	HL,REG_BUFS
	LD	A,(HL)
	XOR	01H
	LD	(HL),A
READCONT:
	LD	HL,REG_FIFOCTRL
	LD	(HL),01H
		;
FRL3:
	LD	A,(REG_FIFOTYPE)
	AND	03H
	JR	NZ,FRL2
	LD	A,(REG_CMTOPEN)
	AND	01H
	JR	Z,FRL4
FRL2:	LD	A,(REG_FIFOWRREQ)
	BIT	1,A
	JR	NZ,FRL4
	BIT	0,A
	JR	Z,FRL3
	XOR	A
	LD	(REG_FIFOCTRL),A
	JR	FRL1
		;
FRL4:	LD	HL,REG_FIFOCTRL
	LD	(HL),00H
	RET


;
; file sector address calculate
;
CALCSECAD:
	LD	A,(CLASTSIZE)
	LD	B,A
	LD	A,(FILESECCNT)
	CP	B
	JR	C,CSA2
	XOR	A
	LD	(FILESECCNT),A

		;
		; search next claster from FAT
		;
	LD	DE,REG_SDADD
	LD	HL,FATST
	LD	BC,0004H
	LDIR
	LD	HL,REG_SDADD
	LD	A,(FILECLASTNO+1)
	CALL	ADD4B_MHL_A

		;
		; read next claster number
		;
	CALL	READ1SEC
	LD	A,(FILECLASTNO)
	LD	L,A
	LD	H,00H
	ADD	HL,HL
	LD	DE,REG_SDBUF
	ADD	HL,DE
	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	LD	(FILECLASTNO),DE
	EX	DE,HL
	LD	DE,0FFF7H
	OR	A
	SBC	HL,DE
	JP	NC,SDERR

		;
		; claster number -> address
		;
		; REG_SDADD <= CLASTST + CLASTSIZE x (FILECLASTNO - 2) + FILESECCNT
		;
CSA2:
	LD	DE,REG_SDADD
	LD	HL,CLASTST
	LD	BC,0004H
	LDIR
		;
	LD	HL,(FILECLASTNO)
	DEC	HL
	DEC	HL
	LD	(WORK),HL
	LD	HL,0000H
	LD	(WORK+2),HL
		;	
	LD	A,(CLASTSIZE)
	LD	B,08H
CSA4:	RRCA
	PUSH	AF
	PUSH	BC
	JR	NC,CSA3
	LD	HL,REG_SDADD
	LD	DE,WORK
	CALL	ADD4B_MHL_MDE
		;
CSA3:	LD	HL,WORK
	CALL	SHT4B_MHL
		;
	POP	BC
	POP	AF
	DJNZ	CSA4
		;
	LD	HL,REG_SDADD
	LD	A,(FILESECCNT)
	CALL	ADD4B_MHL_A
		;
	LD	HL,FILESECCNT
	INC	(HL)
	RET


;
; file claster number seaech
; IX <= file name address
;
FILESEARCH:
	LD	HL,0000H
	LD	(DIRFILEPTR),HL
		;
FSL1:	CALL	READ_DIRFILE
		;
	PUSH	IX
	POP	BC
	LD	A,(HL)
	OR	A
	JP	Z,SDERR
	PUSH	HL
	LD	D,0BH
	CALL	CP_MHL_MBC
	POP	HL
	JR	Z,FSL2
;	JR	NZ,FSL11
;	LD	A,(HL)
;	AND	0FEH
;	CP	20H
;	JR	Z,FSL2

		;
FSL11:
	LD	HL,(DIRFILEPTR)
	INC	HL
	LD	(DIRFILEPTR),HL
	LD	A,H
	CP	02H
	JP	NC,SDERR
	JR	FSL1
		;

FSL2:
	LD	BC,001AH
	ADD	HL,BC
	LD	DE,FILECLASTNO
	LD	BC,0002H
	LDIR
	LD	DE,REG_CMTLEN
	LD	BC,0004H
	LDIR
	LD	HL,FILECLASTNO
	LD	DE,FILECLASTINITNO
	LD	BC,0002H
	LDIR
	RET


;
; rom area initialize
;
ROMINIT:
	LD	HL,REG_SDCTRL
	LD	(HL),08H
	LD	(HL),00H
ROMLP:	LD	A,(HL)
	AND	08H
	JR	NZ,ROMLP


;
; SD card initialized and read parameter
;

; SD card use
;
SDCARD_OPEN:
	LD	HL,REG_SDCTRL
	LD	A,(HL)
	OR	01H
	LD	(HL),A

;
; command 0 (S/W reset)
;
	LD	HL,0000H
	LD	(REG_SDADD),HL
	LD	(REG_SDADD+2),HL
	XOR	A
	CALL	SENDCMD2

;
; command 1 (idle detect)
;
SDW1:	LD	A,01H
	CALL	SENDCMD2
	BIT	1,(HL)
	JR	NZ,SDW1

;
; command 16 (length set)
;
	LD	A,10H
	CALL	SENDCMD

;
; read phisical sector #0
;
	XOR	A
	LD	(REG_BUFS),A
	CALL	READ1SEC
		;
	LD	HL,REG_OFFSET
	LD	DE,OFFSET
	LD	BC,0004H
	LDIR


;
; read logical sector #0 (read BPB parameter)
;
	LD	HL,OFFSET
	LD	DE,REG_SDADD
	LD	BC,0004H
	LDIR
		;
	CALL	READ1SEC
	CALL	CHKSPT
		;
		; claster size = BPB_CLASTSEC
		;
	LD	A,(BPB_CLASTSEC)
	LD	(CLASTSIZE),A

		;
		; FAT start = OFFSET + BPB_FATST
		;
	LD	HL,(OFFSET)
	LD	DE,(BPB_FATST)
	ADD	HL,DE
	LD	(FATST),HL
	LD	HL,(OFFSET+2)
	LD	DE,0000H
	ADC	HL,DE
	LD	(FATST+2),HL
		;
		; root directory start = FATST + BPB_FATNUM x BPB_FATSEC
		;
	LD	DE,ROOTST
	LD	HL,FATST
	LD	BC,0004H
	LDIR
	LD	HL,(BPB_FATSEC)
	LD	(WORK),HL
	LD	HL,0000H
	LD	(WORK+2),HL

	LD	A,(BPB_FATNUM)
	LD	B,08H
RDLP1:	RRCA
	PUSH	AF
	PUSH	BC
	JR	NC,RDLP2
	LD	HL,ROOTST
	LD	DE,WORK
	CALL	ADD4B_MHL_MDE
		;
RDLP2:	LD	HL,WORK
	CALL	SHT4B_MHL
		;
	POP	BC
	POP	AF
	DJNZ	RDLP1

		;
		; claster start = ROOTST + 32
		;
	LD	HL,ROOTST
	LD	DE,CLASTST
	LD	BC,0004H
	LDIR
	LD	HL,CLASTST
	LD	A,20H
	CALL	ADD4B_MHL_A
	RET


;
; root directory set
;
ROOTDIRSET:
	LD	HL,ROOTST
	LD	DE,DIRST
	LD	BC,0004H
	LDIR
	RET


;
; directory file list read
;
; RETURN
; HL:file pointer
;
READ_DIRFILE:
	LD	DE,WORK
	LD	HL,DIRST
	LD	BC,0004H
	LDIR
	LD	HL,(DIRFILEPTR)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	A,H
	LD	HL,WORK
	CALL	ADD4B_MHL_A

		;
	LD	HL,WORK
	LD	BC,REG_SDADD
	LD	D,04H
	CALL	CP_MHL_MBC
	JR	Z,RRL1

		;
	LD	HL,WORK
	LD	DE,REG_SDADD
	LD	BC,0004H
	LDIR
	CALL	READ1SEC
		;
RRL1:	LD	A,01H
	LD	(REG_BUFCTRL),A
	LD	A,(DIRFILEPTR)
	AND	0FH
	LD	L,A
	LD	H,00H
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	DE,REG_SDBUF
	ADD	HL,DE
	RET


;
; (HL)x4b <- (HL)x4b + (DE)x4b
;
ADD4B_MHL_MDE:
	LD	A,(DE)
	ADD	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	RET


;
; (HL)x4b <- (HL)x4b + A
;
ADD4B_MHL_A:
	ADD	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	RET


;
; (HL)x4b <- (HL)x4b x 2
;
SHT4B_MHL:
	OR	A
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	RET


;
; CP (HL),(BC) x D byte
;
; RETURN
; equal : Zflag set
;
CP_MHL_MBC:
CPL1:	LD	A,(BC)
	CP	(HL)
	RET	NZ
	INC	BC
	INC	HL
	DEC	D
	RET	Z
	JR	CPL1


;
; read 1 sector
;
READ1SEC:
	LD	HL,REG_BUFCTRL
	LD	(HL),02H
	LD	(HL),00H
	LD	A,11H
	CALL	SENDCMD
RSL1:	LD	A,(REG_BUFRDREQ)
	OR	A
	JR	Z,RSL1
	LD	A,01H
	LD	(REG_BUFCTRL),A
	RET


SENDCMD:
;
; Areg <= command_No
;
	LD	(REG_SDCMDNO),A
	LD	HL,REG_SDCMDST
	LD	(HL),01H
	DEC	(HL)
SCL1:	BIT	0,(HL)
	JR	NZ,SCL1
	LD	A,06H
	AND	(HL)
	JR	NZ,SDERR
	RET

SENDCMD2:
;
; Areg <= command_No
;
	LD	(REG_SDCMDNO),A
	LD	HL,REG_SDCMDST
	LD	(HL),01H
	DEC	(HL)
SCL2:	BIT	0,(HL)
	JR	NZ,SCL2
	BIT	2,(HL)
	JR	NZ,SDERR
	RET



CHKSPT:
;
; SD card support check
;

	LD	HL,BPB_FATVER
	LD	A,(HL)
	CP	36H
	JR	NZ,SDERR
		;
	LD	HL,BPB_SECBYTE
	LD	A,(HL)
	OR	A
	JR	NZ,SDERR
	INC	HL
	LD	A,(HL)
	CP	02H
	JR	NZ,SDERR
		;
	LD	HL,BPB_DIRENTRY
	LD	A,(HL)
	OR	A
	JR	NZ,SDERR
	INC	HL
	LD	A,(HL)
	CP	02H
	JR	NZ,SDERR
	RET


SDERR:
;
; SD card error
;
;
;
;
	LD	HL,REG_SDCTRL
	LD	A,(HL)
	OR	02H
	AND	0FEH
	LD	(HL),A
	LD	SP,0FFFH
	LD	A,(SDMODE)
	OR	A
ERRLP:	JR	Z,ERRLP
	CP	01H
	JP	Z,MAINSTART
	JP	MAINST2



;
; LCD initialize
;
LCD_INIT:
	LD	DE,00300H
	CALL	LCD_OUTDT
	LD	DE,00001H
	CALL	LCD_OUTDT
	LD	DE,00002H
	CALL	LCD_OUTDT
	LD	DE,0CC03H
	CALL	LCD_OUTDT
	LD	DE,00007H
	CALL	LCD_OUTDT

	LD	A,01H
	LD	(REG_LCDDONE),A

	RET

;
; LCD setting data output
;
LCD_OUTDT:
	LD	HL,REG_LCDST
	XOR	A

	LD	(REG_LCDADD),DE
	LD	(HL),01H
LCDD1:	CP	(HL)
	JR	NZ,LCDD1
	RET


;
; offset address
;
OFFSET:		DB	00H,00H,00H,00H

;
; FAT start address
;
FATST:		DB	00H,00H,00H,00H

;
; root directory start address
;
ROOTST:		DB	00H,00H,00H,00H

;
; claster start address (claster number is #2)
;
CLASTST:	DB	00H,00H,00H,00H

;
; claster size (x512 byte)
;
CLASTSIZE:	DB	00H

;
; read file sector number
;
FILECLASTNO	DB	00H,00H

;
; read file sector number
;
FILECLASTINITNO	DB	00H,00H

;
; sector counter in claster
;
FILESECCNT	DB	00H

;
; directory start address
;
DIRST:		DB	00H,00H,00H,00H

;
; directory file pointer
;
DIRFILEPTR:	DB	00H,00H

;
; 4 byte calc work
;
WORK:		DB	00H,00H,00H,00H

;
; return mode of SD error
;
SDMODE:		DB	00H

;
; read flag
;
; 00H : no selected file
; 01H : selected and no read
; 02H : selected and reading
;
READFLAG	DB	00H

;
; display page number
;
PAGENUM		DB	00H

;
; display page redraw
;
PAGEREDRAW	DB	00H

;
; cursur redraw
;
CURSORREDRAW	DB	00H

;
; directory flag (0:root dir)
;
DIRFLAG		DB	00H

;
; file selecter CMT/EXT.ROM
;
FILEEXTROM	DB	00H

;
; extend rom on/off
;
EXTROMFLAG	DB	00H

;
; control select register buffer / function key buffer
; key push detect
;
CTRLNOW		DB	00H
FUNCNOW		DB	00H,00H,00H
CTRLBEF		DB	00H
FUNCBEF		DB	00H,00H,00H
CTRLPUSH	DB	00H
FUNCPUSH	DB	00H,00H,00H

;
; cursor position address and length
;
CURSOR_ADD	DB	00H,00H
CURSOR_LEN	DB	00H

;
; claster number buffer x 20 x2
;
FILEPTR_BUF	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
		DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

;
; strings
;
ST_PC6001F	DB	009H,00H,"PC-6001F",00H
ST_FPGAVER	DB	015H,00H,"FPGA v."
ST_FPGAVER_VAL	DB	"0000",00H
ST_FIRMVER	DB	036H,00H,"F/W v."
ST_FIRMVER_VAL	DB	"0000",00H
ST_CMTREAD	DB	061H,00H, "CMT READ FILE  ["
ST_CMTREAD_VAL	DB	"FFFFFFFF EEE]",00H
ST_CMTREW	DB	081H,00H,"CMT READ FILE REW.[  OK  ]",00H
ST_CMTWRITE	DB	0C1H,00H, "CMT WRITE FILE ["
ST_CMTWRITE_VAL	DB	"  ",09AH,093H,09CH,0DEH,0E1H,08DH,093H,"   ]",00H
ST_MEMSIZE	DB	001H,01H,"RAM SIZE          ["
ST_MEMSIZE_VAL	DB	" 16KB ]",00H
ST_EXTROM	DB	041H,01H,"EXTEND ROM     ["
ST_EXTROM_VAL	DB	"FFFFFFFF EEE]",00H
ST_SC4COL	DB	081H,01H,"SCREEN4 COLOR    ["
ST_SC4COL_VAL	DB	"/ ]",00H


; ޳:ٷ ò:RET ·:SPC
; ݾ:ESC    :F8  ؾ:F11
;0123456789ABCDEF0123456789ABCDEF

ST_KEYFUNC1	DB	0C0H,001H
		DB	020H,092H,0E4H,0DEH,093H,03AH,0B6H,0B0H
		DB	0BFH,0D9H,0B7H,0B0H,020H,099H,08FH,0E3H
		DB	092H,03AH,052H,045H,054H,020H,0E2H,097H
		DB	0DEH,0EDH,03AH,053H,050H,043H,020H,000H
ST_KEYFUNC2	DB	0E0H,001H
		DB	020H,0B7H,0ACH,0DDH,0BEH,0D9H,03AH,045H
		DB	053H,043H,020H,020H,020H,020H,095H,0FCH
		DB	0F9H,03AH,046H,038H,020H,020H,0D8H,0BEH
		DB	0AFH,0C4H,03AH,046H,031H,031H,020H,000H

ST_FNAME	DB	00H,00H
ST_FNAME_VAL	DB	"FFFFFFFF EEE",00H

ST_DEBUG	DB	0E0H,01H,"HL:"
ST_DEBUG_VAL	DB	"0000",00H

ST_NOSELECT	DB	03DH,03DH,020H,09EH,0FDH,0E0H
		DB	098H,0E5H,09CH,020H,03DH,03DH	;"== ż =="
ST_OFF		DB	" OFF"
ST_HIGH		DB	" ON "
ST_LOW		DB	"LOW "
ST_16		DB	" 16"
ST_32		DB	" 32"
ST_64		DB	" 64"
ST_128		DB	"128"
ST_SC4COL0	DB	0F0H,0E4H,0DEH,0F8H,02FH,0F3H,0F3H,020H	;"/ "
ST_SC4COL1	DB	0F3H,0F3H,02FH,0F0H,0E4H,0DEH,0F8H,020H	;"/ "
ST_SC4COL2	DB	020H,091H,095H,02FH,091H,096H,020H,020H	;" /  "
ST_SC4COL3	DB	020H,091H,096H,02FH,091H,095H,020H,020H	;" /  "
ST_SC4COLOFF	DB	"  OFF   "

;
; page 0 cursor data
;
PAGE0CURDATA	DB	071H,000H,00CH
		DB	094H,000H,006H
		DB	0B4H,000H,006H
		DB	0D1H,000H,00CH
		DB	0F1H,000H,001H
		DB	014H,001H,006H
		DB	031H,001H,001H
		DB	051H,001H,00CH
		DB	071H,001H,001H
		DB	093H,001H,008H

	END
